import { Logger } from './logger.js';
import { Config } from '../types/index.js';
import 'node:http';
import 'discord.js';

declare const ALLOWED_EXTENSIONS: string[];
declare const Highlight: (s: string) => string;
declare const Indent: string;
declare const Space: string;
declare const cloudflareLogger: Logger;
declare const discordLogger: Logger;
declare const DEFAULT_CONFIG: Config;
declare const FLASHCORE_KEYS: {
    commandRegisterError: string;
    lastUpdateCheck: string;
    state: string;
};
declare const STATE_KEYS: {
    restart: string;
};
declare const BUFFER: unique symbol;
declare const TIMEOUT: unique symbol;

export { ALLOWED_EXTENSIONS, BUFFER, DEFAULT_CONFIG, FLASHCORE_KEYS, Highlight, Indent, STATE_KEYS, Space, TIMEOUT, cloudflareLogger, discordLogger };
