import { Client } from 'discord.js';
import Portal from './portal.js';
import '../types/index.js';
import 'node:http';
import './logger.js';

declare const Robo: {
    restart: typeof restart;
    start: typeof start;
    stop: typeof stop;
};
declare let client: Client;
declare let portal: Portal;
interface StartOptions {
    client?: Client;
    stateLoad?: Promise<void>;
}
declare function start(options?: StartOptions): Promise<void>;
declare function stop(exitCode?: number): Promise<void>;
declare function restart(): Promise<void>;

export { Robo, client, portal };
