import { portal } from './robo.js';
import { timeout, getSage } from '../cli/utils/utils.js';
import { getConfig } from './config.js';
import { discordLogger, BUFFER, TIMEOUT, DEFAULT_CONFIG } from './constants.js';
import { printErrorResponse } from './debug.js';
import { color } from './color.js';
import h from 'node:path';

const j=["boolean","integer","number","string"];async function O(r,i){const n=portal.commands.get(i);if(!n){discordLogger.error(`No command matching ${i} was found.`);return}if(!portal.module(n.module).isEnabled){discordLogger.debug(`Tried to execute disabled command from module: ${color.bold(n.module)}`);return}try{for(const s of portal.middleware){discordLogger.debug(`Executing middleware: ${color.bold(h.join(s.plugin?.path??".",s.path))}`);const l=await s.handler.default({payload:[r],record:n});if(l&&l.abort){discordLogger.debug(`Middleware aborted autocomplete: ${color.bold(r.commandName)}`);return}}}catch(s){discordLogger.error("Aborting due to middleware error:",s);return}const c=getConfig();try{discordLogger.debug(`Executing autocomplete handler: ${color.bold(h.join(n.plugin?.path??".",n.path))}`);const s=[n.handler.autocomplete(r)],l=c?.timeouts?.autocomplete;l&&s.push(timeout(()=>[],l));const e=await Promise.race(s);if(!e)throw new Error("Autocomplete timed out");await r.respond(e);}catch(s){discordLogger.error("Autocomplete error:",s);}}async function B(r,i){const n=portal.commands.get(i);if(!n){discordLogger.error(`No command matching "${i}" was found.`);return}if(!portal.module(n.module).isEnabled){discordLogger.debug(`Tried to execute disabled command from module: ${color.bold(n.module)}`);return}try{for(const e of portal.middleware){discordLogger.debug(`Executing middleware: ${color.bold(h.join(e.plugin?.path??".",e.path))}`);const d=await e.handler.default({payload:[r],record:n});if(d&&d.abort){discordLogger.debug(`Middleware aborted command: ${color.bold(i)}`);return}}}catch(e){discordLogger.error("Aborting due to middleware error:",e);return}const c=n.handler.config,s=getConfig(),l=getSage(c,s);discordLogger.debug("Sage options:",l);try{if(discordLogger.debug(`Executing command handler: ${color.bold(h.join(n.plugin?.path??".",n.path))}`),!n.handler.default)throw `Missing default export function for command: ${color.bold("/"+i)}`;const e={};c?.options?.forEach(a=>{if(j.includes(a.type))e[a.name]=r.options.get(a.name)?.value;else if(a.type==="attachment")e[a.name]=r.options.get(a.name)?.attachment;else if(a.type==="channel")e[a.name]=r.options.get(a.name)?.channel;else if(a.type==="mention"){const p=r.options.get(a.name);e[a.name]=p?.member??p?.role;}else a.type==="role"?e[a.name]=r.options.get(a.name)?.role:a.type==="user"?e[a.name]=r.options.get(a.name)?.user:a.type==="member"&&(e[a.name]=r.options.get(a.name)?.member);});const d=n.handler.default(r,e),u=[];let t;if(l.defer&&d instanceof Promise){const a=timeout(()=>BUFFER,l.deferBuffer),p=await Promise.race([d,a]);if(p===BUFFER&&!r.replied){if(discordLogger.debug("Sage is deferring async command..."),u.push(d),!r.deferred)try{await r.deferReply({ephemeral:l.ephemeral});}catch(C){const $=C instanceof Error?C.message:C;if(!$.includes("Unknown interaction")&&!$.includes("Interaction has already been acknowledged"))throw C;discordLogger.debug("Interaction was already handled, skipping Sage deferral");}}else t=p;}if(u.length>0){if(s?.timeouts?.commandDeferral&&u.push(timeout(()=>TIMEOUT,s.timeouts.commandDeferral)),t=await Promise.race(u),t===TIMEOUT)throw new Error("Command timed out")}else d instanceof Promise||(t=d);if(t===void 0){discordLogger.debug("Command returned void, skipping response");return}discordLogger.debug("Sage is handling reply:",t);const g=typeof t=="string"?{content:t}:t;r.deferred?await r.editReply(g):await r.reply(g);}catch(e){discordLogger.error(e),printErrorResponse(e,r);}}async function L(r,i){const n=portal.context.get(i);if(!n){discordLogger.error(`No context menu command matching "${i}" was found.`);return}if(!portal.module(n.module).isEnabled){discordLogger.debug(`Tried to execute disabled context menu command from module: ${color.bold(n.module)}`);return}try{for(const e of portal.middleware){discordLogger.debug(`Executing middleware: ${color.bold(h.join(e.plugin?.path??".",e.path))}`);const d=await e.handler.default({payload:[r],record:n});if(d&&d.abort){discordLogger.debug(`Middleware aborted context command: ${color.bold(i)}`);return}}}catch(e){discordLogger.error("Aborting due to middleware error:",e);return}const c=n.handler.config,s=getConfig(),l=getSage(c,s);discordLogger.debug("Sage options:",l);try{if(discordLogger.debug(`Executing context menu handler: ${color.bold(h.join(n.plugin?.path??".",n.path))}`),!n.handler.default)throw `Missing default export function for command: ${color.bold("/"+i)}`;let e;r.isMessageContextMenuCommand()?e=r.targetMessage:r.isUserContextMenuCommand()&&(e=r.targetUser);const d=n.handler.default(r,e),u=[];let t;if(l.defer&&d instanceof Promise){const a=timeout(()=>BUFFER,l.deferBuffer),p=await Promise.race([d,a]);p===BUFFER&&!r.replied?(discordLogger.debug("Sage is deferring async command..."),u.push(d),r.deferred||await r.deferReply({ephemeral:l.ephemeral})):t=p;}if(u.length>0){if(s?.timeouts?.commandDeferral&&u.push(timeout(()=>TIMEOUT,s.timeouts.commandDeferral)),t=await Promise.race(u),t===TIMEOUT)throw new Error("Context menu command timed out")}else d instanceof Promise||(t=d);if(t===void 0){discordLogger.debug("Context menu command returned void, skipping response");return}discordLogger.debug("Sage is handling reply:",t);const g=typeof t=="string"?{content:t}:t;r.deferred?await r.editReply(g):await r.reply(g);}catch(e){discordLogger.error(e),printErrorResponse(e,r);}}async function _(r,i,...n){const c=portal.events.get(i);if(!c?.length)return Promise.resolve();const s=getConfig(),l=i.startsWith("_");await Promise.all(c.map(async e=>{try{if(discordLogger.debug(`Executing event handler: ${color.bold(h.join(e.plugin?.path??".",e.path))}`),!e.handler.default)throw `Missing default export function for event: ${color.bold(i)}`;if(!portal.module(e.module).isEnabled){discordLogger.debug(`Tried to execute disabled event from module: ${color.bold(e.module)}`);return}try{for(const t of portal.middleware){discordLogger.debug(`Executing middleware: ${color.bold(h.join(t.plugin?.path??".",t.path))}`);const g=await t.handler.default({payload:n,record:e});if(g&&g.abort){discordLogger.debug(`Middleware aborted event: ${color.bold(i)}`);return}}}catch(t){discordLogger.error("Aborting due to middleware error:",t);return}const d=e.handler.default(...n,r?.get(e.plugin?.name)?.options);if(!l)return await d;const u=timeout(()=>TIMEOUT,s?.timeouts?.lifecycle||DEFAULT_CONFIG.timeouts.lifecycle);return await Promise.race([d,u])}catch(d){try{const u=r?.get(e.plugin?.name)?.metaOptions??{};let t;d===TIMEOUT?(t=`${i} lifecycle event handler timed out`,discordLogger.warn(t)):e.plugin?i==="_start"&&u.failSafe?(t=`${e.plugin.name} plugin failed to start`,discordLogger.warn(t,d)):(t=`${e.plugin.name} plugin error in event ${i}`,discordLogger.error(t,d)):(t=`Error executing ${i} event handler`,discordLogger.error(t,d)),printErrorResponse(d,n[0],t,e);}catch(u){discordLogger.error("Error handling event error...",u);}}}));}function G(r){return r}

export { G as createCommandConfig, O as executeAutocompleteHandler, B as executeCommandHandler, L as executeContextHandler, _ as executeEventHandler };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=handlers.js.map